= How do I use OpenSCAP to scan the web application server? =
[[TOC(heading=How do I...?,depth=1,HowTo/*)]]

[http://www.open-scap.org OpenSCAP] is a policy management tool developed and maintaind by NIST. It is used to identify poor configurations and indications of a compromise. 

For SecureCI, OpenSCAP can only be run locally. This will require target systems to install the application before running, which can be performed through Jenkins. 

OpenSCAP is a powerful tool with the potential to quickly scan new environments or webservers for vulnerabilities. This tool does not perform active attacks. It compares current system settings and configurations with established best practice baselines according to NIST. New templates can be imported from additional sources or created for a custom solution. 

== Usage ==

The OpenSCAP tool is a command line program that needs policy rulesets to use as a baseline. There are several great starting policy sets within git. Local versions can be obtained via:
		git clone https://github.com/GovReady/ubuntu-scap.git
This bundle includes ssg-rhel6-oval.xml, ubuntu-cpe-oval.xml, ubuntu-ccpe.xml, ubuntu-xccdf.xml, and have imported to <%= node['openscap']['scantemplates'] %> with this tool’s installation. 

[[br]]
Execute the security scanning tool with this command line usage:
		oscap [general-options] module operation [operation-options-and-arguments]

Command line options:
[[br]]--profile [profile_name] 	Selects a specific profile.To determine the profiles available within the dictionary policies, query the file itself:		
[[br]]		oscap info “[policy_path/target_policy_file]”
[[br]]--results [file.xml]   		Writes XCCDF results to file
[[br]]--report [report.html]		Writes results file into HTML report to file for easy method of review. This command requires the --results

[[br]]There are several options for modules to execute: 
[[br]]xccdf  						The eXtensible Configuration Checklist Description Format and utilizes this format to evaluate the platform. 
[[br]]oval						Open Vulnerability and Assessment Language used to assess the system and evaluate according to its own OVAL definition files
[[br]]cpe    						Common Platform Enumeration is used to verify dictionary files 
[[br]]cvss   						Common Vulnerability Scoring System is used to compile the results of other modules and generate metrics 


[[br]]Each module has its own unique set of operations. XCCDF and OVAL perform the vulnerability analysis by using the eval command. 
[[br]]eval						Evaluates the system using either an XCCDF or OVAL input file. If the execution completed and every rule passes, a 0 is returned. A 1 is returned if errors prevented a successful completion and a 2 is returned if the execution completed but at least one rule failed. 
[[br]]For a complete list of the commands and capabilities of the OpenSCAP tool, refer to the manual at: 
	http://manpages.ubuntu.com/manpages/precise/man8/oscap.8.html

For functional usage of OpenSCAP, use the following command line structure:
	sudo oscap xccdf eval --profile [profile_name] --results [output_file.xml] --report [output_report.html] [xccdf_policy_template.xml]

Sample dictionary policies to be used for comparison can be found online. For a good starting point, use the download files available at the Open Vulnerabilities and Assessment Language page. 
	http://oval.mitre.org/language/index.html
Another sample test to run to check the policies of a RHEL5 system is detailed below:
		oscap xccdf eval --fetch-remote-resources --oval-results --profile united_states_government_configuration_baseline --report report-usgcb.html 
		--results results-usgcb.xml –cpe usgcb-rhel5desktop-cpe-dictionary.xmll usgcb-rhel5desktop-xccdf.xml

[[br]]		oscap xcccdf eval --profile xccdf_ubuntu_profile_default --cpe ubuntu-cpe.xml --check-engine-results --oval-results --results results.xml --report results.html ubuntu-xccdf.xml



=== How to install OpenSCAP locally on target systems ===

To run OpenSCAP from the target's command line, have Jenkins either ssh to the system or control it directly as a child Jenkins box. Then run these commands locally:

{{{

	sudo apt-get install libopenscap8

}}} 

When the installation has completed, place the desired policy template on the system and run:

{{{

	sudo oscap oval eval --results results.xml --report report.html policy_template.xml

}}} 

